/*
 * Copyright (c) 1989, 1993, 1994
 * The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * Michael Fischbein.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 * This product includes software developed by the University of
 * California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id$
 */

/*
 * written by shige <shige@kuis.kyoto-u.ac.jp>
 */

#include <stdio.h>

int samba_cap(char *s)
{
	char *sp;
	int i = 0;
	char tmpnum;
	char tmp[FILENAME_MAX];

	sp = s;

	while(*s != '\0') {
		if (*s == ':') {
			if ('9' >= *(s+1) && *(s+1) >= '0')
				tmpnum = (*(s+1) - 0x30) * 16;
			else if ('f' >= *(s+1) && *(s+1) >= 'a')
				tmpnum = (*(s+1) - 0x60 + 9) * 16;
			else {
      				tmp[i] = *s;
      				tmp[i+1] = *(s+1);
				*s = '\0';
				*(s+1) = '\0';
				i += 2;
				s += 2;
				continue;
			}

			if ('9' >= *(s+2) && *(s+2) >= '0')
				tmpnum = (*(s+2) - 0x30) + tmpnum;
			else if ('f' >= *(s+2) && *(s+2) >= 'a')
				tmpnum = (*(s+2) - 0x60 + 9) + tmpnum;
			else {
      				tmp[i] = *s;
      				tmp[i+1] = *(s+1);
      				tmp[i+2] = *(s+2);
				*s = '\0';
				*(s+1) = '\0';
				*(s+2) = '\0';
				i += 3;
				s += 3;
				continue;
			}

			tmp[i] = tmpnum;
			*s = '\0';
			*(s+1) = '\0';
			*(s+2) = '\0';
			i++;
			s += 3;
		} else {
			tmp[i] = *s;
			*s = '\0';
			i++;
			s++;
		}
	}

	tmp[i] = '\0';
	strcpy(sp, tmp);

	return 0;
}

#ifdef DEBUG_TEST
int main()
{
	char *name = ":90V:82:b5:82:a2:83t:83H:83:8b:83_";
	char new[1024];

	strcpy(new, name);
	samba_cap(new);

	printf("converted: %s\n", new);
	return 0;
}
#endif
